HDU3949 XOR(线性基第k小)

Problem Description

XOR is a kind of bit operator, we define that as follow: for two binary base number A and B, let C=A XOR B, then for each bit of C, we can get its value by check the digit of corresponding position in A and B. And for each digit, 1 XOR 1 = 0, 1 XOR 0 = 1, 0 XOR 1 = 1, 0 XOR 0 = 0. And we simply write this operator as ^, like 3 ^ 1 = 2,4 ^ 3 = 7. XOR is an amazing operator and this is a question about XOR. We can choose several numbers and do XOR operatorion to them one by one, then we get another number. For example, if we choose 2,3 and 4, we can get 2^3^4=5. Now, you are given N numbers, and you can choose some of them(even a single number) to do XOR on them, and you can get many different numbers. Now I want you tell me which number is the K-th smallest number among them.

Input

First line of the input is a single integer T(T<=30), indicates there are T test cases.
For each test case, the first
line is an integer N(1<=N<=10000), the number of numbers below. The second
line contains N integers (each number is between 1 and 10^18). The third line is
a number Q(1<=Q<=10000), the number of queries. The fourth line contains Q
numbers(each number is between 1 and 10^18) K1,K2,......KQ.

Output

For each test case,first output Case #C: in a single
line,C means the number of the test case which is from 1 to T. Then for each
query, you should output a single line contains the Ki-th smallest number in
them, if there are less than Ki different numbers, output -1.

Sample Input

2
2
1 2
4
1 2 3 4
3
1 2 3
5
1 2 3 4 5

Sample Output

Case #1:
1
2
3
-1
Case #2:
0
1
2
3
-1

Hint

If you choose a single number, the result you get is the number you choose.
Using long long instead of int because of the result may exceed 2^31-1.

Author

elfness

Source

题目大意:给出$n$个数,问两两异或后第$k$小的数是多少

看了很多篇博客,发现都是在围绕着高斯消元解xor方程组来的。

然后我惊讶的发现,原来高斯消元解xor解方程组其实就是求出线性基然后再消元

通过消元保证线性基内有元素的每一列只有一个$1$

然后把$k$二进制分解,如果第$i$是$1$就异或上第$i$个有解的线性基

同时要特判$0$的情况,若线性基的大小与元素的大小相同则不能异或为$0$(线性无关),否则可以异或为零,这时我们只要求出第$k-1$小就可以了

这里把$k$二进制分解后的$0/1$实际对应了线性基中元素选/不选,可以证明这样一定是对的

#include<cstdio>
#include<cstring>
#include<algorithm>
#define int  long long
using namespace std;
const int MAXN = 1e5 + 10,  B = 31;
inline int read() {
    char c = getchar(); int x = 0, f = 1;
    while(c < ‘0‘ || c > ‘9‘) {if(c == ‘-‘) f = -1; c = getchar();}
    while(c >= ‘0‘ && c <= ‘9‘) x = x * 10 + c - ‘0‘, c = getchar();
    return x * f;
}
int  P[MAXN];
void Insert(int  x) {
    for(int i = B; i >= 0; i--) {
        if((x >> i) & 1) {
            if(P[i]) x = x ^ P[i];
            else {P[i] = x; return ;}
        }
    }
}
void Debug(int *a, int N) {
    for(int i = 0; i <= N; i++) {
        for(int j = 0; j <= B; j++)
            printf("%d ", (P[i] >> j) & 1);
        puts("");
    }
    puts("********");
}
main() {
    int QwQ = read();
    for(int test = 1; test <= QwQ; test++) {
        printf("Case #%I64d:\n", test);
        memset(P, 0, sizeof(P));
        int  N = read();
        for(int i = 1; i <= N; i++)
            Insert(read());
        for(int i = B; i >= 0; i--) {
            if(P[i]) {
                for(int j = i + 1; j <= B; j++)
                    if((P[j] >> i) & 1) P[j] ^= P[i];
            }
        }
        int now = 0;
        for(int i = 0; i <= B; i++)
            if(P[i])
                P[now++] = P[i];
        int Q = read();
        while(Q--) {
            int  K = read(), ans = 0;
            if(now != N) K--;
            if(K >= (1ll  << now)) {puts("-1"); continue;}
            for(int i = 0; i <= B; i++)
                if((K >> i) & 1)
                    ans ^= P[i];
            printf("%I64d\n", ans);
        }
    }
}

原文地址:https://www.cnblogs.com/zwfymqz/p/9192926.html

时间: 2024-08-29 17:43:25

HDU3949 XOR(线性基第k小)的相关文章

[hdu3949]XOR(线性基求xor第k小)

题目大意:求xor所有值的第k小,线性基模板题. #include<cstdio> #include<cstring> #include<algorithm> #include<cstdlib> #include<iostream> #include<cmath> using namespace std; typedef long long ll; const int MAX_BASE=63; ll base[64],a[10006]

【HDU3949】XOR 线性基

#include <stdio.h> int main() { puts("转载请注明出处谢谢"); puts("http://blog.csdn.net/vmurder/article/details/43448493"); } 题意:给若干个数让你异或,然后询问第k大的异或和. 题解: 先搞出来线性基,然后第k大的异或和就是: 把k二进制拆分,第i位上有1,就把第i个线性基异或进来. 原因: 因为线性基是一堆高位上的1(或许有一些位动不了),然后把这

hdu 3949 XOR (线性基)

链接: http://acm.hdu.edu.cn/showproblem.php?pid=3949 题意: 给出n个数,从中任意取几个数字异或,求第k小的异或和 思路: 线性基求第k小异或和,因为题目中可以出现异或和为0的情况,但线性基里是不会出现异或和为0的情况,所以我们需要多处理下,将数字全插入到线性基中,如果无法插入也就代表会出现异或和为0的情况,那么求第k小就应该变成求线性基中第k-1小. 实现代码: #include<bits/stdc++.h> using namespace s

HDU 3949 XOR(线性基)

题意:给出一组数,求最小的第k个由这些数异或出来的数. 先求这组数的线性基.那么最小的第k个数显然是k的二进制数对应的线性基异或出来的数. # include <cstdio> # include <cstring> # include <cstdlib> # include <iostream> # include <vector> # include <queue> # include <stack> # includ

BZOJ 2115 [Wc2011] Xor ——线性基

[题目分析] 显然,一个路径走过两边是不需要计算的,所以我么找到一条1-n的路径,然后向该异或值不断异或简单环即可. 但是找出所有简单环是相当复杂的,我们只需要dfs一遍,找出所有的环路即可,因为所有的简单环都可以经过各种各样的异或得到. 然后线性基,在从高位向低位贪心即可,至于证明,需要拟阵的相关知识. [代码] #include <cstdio> #include <cstring> #include <cstdlib> #include <cmath>

BZOJ 2115: [Wc2011] Xor 线性基

题目链接:http://www.lydsy.com/JudgeOnline/problem.php?id=2115 解法: 膜:http://www.cnblogs.com/ljh2000-jump/p/5869925.html 这道题要求从1到n的最大xor和路径,存在重边,允许经过重复点.重复边.那么在图上作图尝试之后就会发现,路径一定是由许多的环和一条从1到n的路径组成.容易发现,来回走是没有任何意义的,因为来回走意味着抵消.考虑这道题求得是路径xor和最大,所以必然我们要想办法处理环的情

【BZOJ-2115】Xor 线性基 + DFS

2115: [Wc2011] Xor Time Limit: 10 Sec  Memory Limit: 259 MBSubmit: 2142  Solved: 893[Submit][Status][Discuss] Description Input 第一行包含两个整数N和 M, 表示该无向图中点的数目与边的数目. 接下来M 行描述 M 条边,每行三个整数Si,Ti ,Di,表示 Si 与Ti之间存在 一条权值为 Di的无向边. 图中可能有重边或自环. Output 仅包含一个整数,表示最大

BZOJ 3105: [cqoi2013]新Nim游戏 [高斯消元XOR 线性基]

以后我也要用传送门! 题意:一些数,选择一个权值最大的异或和不为0的集合 终于有点明白线性基是什么了...等会再整理 求一个权值最大的线性无关子集 线性无关子集满足拟阵的性质,贪心选择权值最大的,用高斯消元判断是否和已选择的线性相关 每一位记录pivot[i]为i用到的行 枚举要加入的数字的每一个二进制为1的位,如果有pivot[i]那么就异或一下(消元),否则pivot[i]=这个数并退出 如果最后异或成0了就说明线性相关... #include <iostream> #include &l

【BZOJ2115】【Wc2011】 Xor 线性基 异或最长路

#include <stdio.h> int main() { puts("转载请注明出处谢谢"); puts("http://blog.csdn.net/vmurder/article/details/43410545"); } 题意:找一条异或最长路. 题解:先随便来一条路径,然后我们发现这条路径上可以随便加简单环(不管有没有共点共边). 就是因为可以先从某点走到环上来一圈再走回来,这样来去的路径被搞没了,简直污得不行. 然后我们可以用线性基来决定去